part of masamune;

extension WidgetRefValueExtensions on WidgetRef {
  T getAsValue<T>(
    String key,
    T value, {
    List<Object> keys = const [],
  }) {
    final container = get<_ValueContainer<T>?>(key, null);
    if (container == null || container.keys != keys) {
      final updated = this[key] = _ValueContainer<T>(
        value: value,
        keys: keys,
      );
      return updated.value;
    }
    return container.value;
  }
}

@immutable
class _ValueContainer<T> extends DisposableContainer {
  const _ValueContainer({
    required this.value,
    required this.keys,
  });

  final T value;
  final List<Object> keys;
}
